
#ifndef GPATH_H
#define GPATH_H

#include "PathFinder.h"

class GBoard; 
class GPath;

class GPathIterator
{
public:
	GPathIterator(GPath* pPath);
	void Reset();
	char NextMove(int* pnX, int *pnY);
protected:
	int m_nCurMove;
	int m_nDistance;
	int **m_nPathArray;
	GPath* m_pPath;
};

class GPoint
{
public:
	int m_nX;
	int m_nY;

};

class GPath
{
public:
	GPath(GBoard* pBoard);
	~GPath();

	int FindPath(int nSX, int nSY, int nDX, int nDY);  // returns distance, 0 if no path found
	int GetDistance(){return m_nDistance;}
	const char* GetID(){return m_sID;}

	void GetMove(int nMove, int* pnX, int *pnY);
	//_asNode* GetHeadNode(){ return m_asHeadNode; }
	//int** GetPath(){return m_nPath;}

protected:
	static int Valid(int x, int y, void *p);
	static int Cost(int x, int y, void *p);

	GBoard* m_pBoard;
	//CPathFinder	m_PathFinder;
	//_asNode* m_asHeadNode;

	GPoint *m_nPath;
	//int m_nPath[100][2];

	int m_nSX;
	int m_nSY;
	int m_nDX;
	int m_nDY;
	int m_nDistance;
	char m_sID[32];
};

#endif