#ifndef GSMARTBOT_H
#define GSMARTBOT_H

#include "GBot.h"
#include "GPath.h"

class GBoard;
class GPackage;

class GSmartBot : public GBot
{
public:
	GSmartBot(int nID, int nMaxWeight, int nMoney, GBoard* pBoard);
	~GSmartBot();

	virtual void PickedupPackage(int nPackage);
	virtual void DroppedPackage(int nPackage);
	//virtual void OnMoved(char cCmd, int nValue);
	void OnAllBotsUpdated();

	const char*GetNextCmd();
	void OnPackagesFound();
	
protected:
	void PickNextBase();
	BOOL PickNextPackageToDeliver();
	BOOL IsAdjacentBots();

	char m_cCurCmd;
	int m_nDestX;
	int m_nDestY;
	int m_nNextX; // the next spot we should end up after updates
	int m_nNextY; 
	GPath* m_pPath;	
	GPathIterator* m_pPathIterator;
	//GPackage* m_pCurPackage;

	int m_nGoingToBase;
	int m_nDeliveringPackage;
	int m_nPushCount;
	//int m_nPickUpPackage;
};

#endif