#ifndef SSOCKET_H
#define SSOCKET_H


#include "SObject.h"
#include "SDefs.h"
#include "tcp4u.h"

class SSocket :public SObject// _SWISH_
{
public:
	SSocket(SOCKET& Socket);
	SSocket(BOOL bLocalSocket=FALSE);


	~SSocket();// _SWISH_

	int Abort();
	//int TcpAccept (SOCKET *pCSock, SOCKET ListenSock, UINT nTO);
	virtual int Connect (LPCSTR szServer, unsigned short lpPort);	// _SWISH_
	virtual int Close ();// _SWISH_
	virtual void ShutDown();// _SWISH_
	int Flush ();// _SWISH_
	//int TcpGetListenSocket (SOCKET *pS, LPCSTR szService, unsigned short *lpPort, int nPendingConnection);
	int Recv (LPSTR szBuf, unsigned uBufSize, unsigned uTimeOut);
	int Send (LPCSTR szBuf, unsigned uBufSize, BOOL bHighPriority=FALSE);// _SWISH_

	
	const char *GetLocalIPString();// _SWISH_

	SOCKET GetSOCKET(); // returns the SOCKET file descriptor

	BOOL IsDataAvail ();
	BOOL IsOOBDataAvail ();

	/* PP protocole (2 first bytes contain length of data) */
	int PPRecv ( LPSTR szBuf, unsigned uBufSize, unsigned uTimeOut, BOOL bExact);
	int PPSend ( LPCSTR szBuf, unsigned uBufSize);

	/* Recv Until family */
	int RecvUntilStr ( LPSTR szBuf,unsigned *lpBufSize,
							  LPSTR szStop, unsigned uStopSize, BOOL bCaseSensitive,
							  unsigned uTimeOut);

	// call this after listen to see if a socket is awaiting connection, nTO is Time out in seconds
	int Accept(SOCKET* pSocket, int nTO);


	// telnet functions
	int ReadMultiLine ( LPSTR szBuf, UINT BufSize, UINT uTimeOut);
	int ReadLine (LPSTR szBuf, UINT BufSize, UINT uTimeOut);
	//int SendMultiLine ( LPCSTR szString, BOOL bEnd);
	int SendLine ( LPCSTR szString, BOOL bHighPriority=FALSE);
	int GetAnswerCode(LPSTR szInBuf,UINT uBufSize,UINT uTimeOut);

	int SetNonBlocking();

	/*
	typedef BOOL (CALLBACK far *TRANSFER_CBK) (
	#ifdef NEED_PROTO
		long, long, long, LPSTR
	#endif
	);
	int TcpRecvUntilClosedEx (SOCKET       *pCSock,     LPCSTR szLocalFile, 
									TRANSFER_CBK  CbkTransmit,
									unsigned      uTimeout,   unsigned int  uBufSize, 
									long          lUserValue, long          lTotalBytes);

	  */

//protected:
	SOCKET m_Socket;
	BOOL m_bLocalSocket;
};

#endif

