
#include "SSocket.h"
#include "GObjList.h"


class GPackage;


class GHomeBase
{
public:
	GHomeBase(int nID, int nX, int nY)
	{
		m_nID=nID;
		m_nX=nX;
		m_nY=nY;
		m_nPackageCnt=-1;
	}
	int m_nID;
	int m_nX;
	int m_nY;
	int m_nPackageCnt;	// count of packages -1 is unknown

};

class GBoard
{
public:
	GBoard();

	void ReceiveBoard(SSocket* pSocket);
	void AddPackage(int nPackage, int nSX, int nSY, int nDestX, int nDestY, int nWeight);
	void SetMaxWeight(int nWeight) { m_nMaxWeight=nWeight; }
	void ResetBasePackageCount(int nX, int nY);
	void ResetPickedPackages();
	BOOL ArePackagesHere(int nX, int nY);


	GPackage* FindBestDelivery(int nSX, int nSY, int nMaxWeight);
	int FindClosestBase(int nX, int nY, int nExclude=-1);
	GHomeBase* IsHomeBase(int nX, int nY);
	GPackage* FindPackage(int nPackage);
	void RemovePackage(int nPackage);

	int HomeBaseX(int nID);
	int HomeBaseY(int nID);	
	int m_nWidth;
	int m_nHeight;
	char **m_pBoard;

protected:
	GObjList m_HomeBase;
	GObjList m_Packages;
	int m_nMaxWeight;
};