#include "GObjList.h"


GObjList::GObjList()
{
	m_pHead=new GObj(-1, NULL);
	m_pTail=m_pHead;
	m_pCur=m_pHead;
	m_nCount=0;
}

void GObjList::AddObj(int nID, void* pData)
{
	GObj* pObj=new GObj(nID, pData);
	m_pTail->m_pNextObj=pObj;
	pObj->m_pPrevObj=m_pTail;
	m_pTail=m_pTail->m_pNextObj;	
	m_nCount++;
}

void* GObjList::RemoveObj(int nID)
{
	BOOL bFound=FALSE;
	GObj* pObj=m_pHead;
	while(pObj)
	{
		if(pObj->m_nID==nID)
		{
			bFound=TRUE;
			break;
		}
		pObj=pObj->m_pNextObj;
	}

	if(!bFound)
		return NULL;	
	if(pObj->m_pPrevObj)
		pObj->m_pPrevObj->m_pNextObj=pObj->m_pNextObj;
	if(pObj->m_pNextObj)
		pObj->m_pNextObj->m_pPrevObj=pObj->m_pPrevObj;

	if(m_pTail==pObj)
		m_pTail=pObj->m_pPrevObj;
	void * nData=pObj->m_pData;
	delete pObj;
	m_nCount--;

	return nData;
}

void* GObjList::FindObj(int nID)
{
	GObj* pObj=m_pHead;
	while(pObj)
	{
		if(pObj->m_nID==nID)
			return pObj->m_pData;

		pObj=pObj->m_pNextObj;
	}

	return NULL;
}

void* GObjList::FirstObj()
{
	m_pCur=m_pHead;
	return NextObj();
}


void* GObjList::NextObj()
{
	m_pCur=m_pCur->m_pNextObj;
	if(!m_pCur)
		return NULL;
	return m_pCur->m_pData;
}