#include "GBoard.h"
#include "GPath.h"
#include "GPathCache.h"
#include "SStringList.h"
#include "main.h"
#include "stdio.h"
#include "zlib.h"  // for adler32

GPathCache::GPathCache(GBoard* pBoard)
{
	m_pBoard=pBoard;
}

GPath* GPathCache::FindPath(int nSX, int nSY, int nDX, int nDY)
{
	char sID[1024];
	sprintf(sID, "%04i%04i%04i%04i", nSX, nSY, nDX, nDY); // must match GPath sID
	//int nID=adler32(0, (const Bytef*)sID, strlen(sID));    
	//GPath* pPath=(GPath*) m_PathCache.FindObj(nID);

	GPath* pPath=(GPath*)m_PathCache.FirstObj();
	BOOL bFound=FALSE;
	while(pPath)
	{
		if(strcmp(sID, pPath->GetID())==0)
		{
			bFound=TRUE;
			break;
		}
		pPath=(GPath*)m_PathCache.NextObj();
	}

	if(!bFound)
	{
		pPath=new GPath(m_pBoard);
		pPath->FindPath(nSX, nSY, nDX, nDY);
		m_PathCache.AddObj(m_PathCache.Count(), pPath);
	}	
	return pPath;
}


void GPathCache::ReleasePath(GPath* pPath)
{
}


	
